<template>
  <div class="comment_grid_item">
    <article class="comment_article">
      <header class="comment_article_header">
        <div class="product-thumb">
          <a class="product-cover" :href="comment.album.url">
            <img
              class="product-cover-img"
              :src="albumCoverUrl"
              :alt="comment.album.title"
            />
          </a>
          <span v-if="comment.album.rating > 0" class="product_rating text--md">
            {{ $t('newsfeed.hisrate') }}
            <StarRank :avgstar="comment.album.rating" :countnote="0" />
          </span>
        </div>
        <h4
          v-if="$utils.getType(comment.album) == 'volume'"
          class="product_title text text--sm text--primary text--bold"
        >
          {{ commentSerieVolume }}
        </h4>
        <h4
          v-else-if="$utils.getType(comment.album) == 'chapter'"
          class="product_title text text--sm text--primary text--bold"
        >
          {{ commentSerieChapter }}
        </h4>
        <h4 v-else class="product_title text text--sm text--primary text--bold">
          {{ comment.album.title }}
        </h4>
        <StarRank
          :avgstar="comment.album.rate"
          :countnote="comment.album.rate_amount"
        />
      </header>
      <div class="comment_article_container">
        <div class="review-content" itemprop="description">
          <span
            class="text text--md"
            v-html="truncateText(comment.comment)"
          ></span>
          <a
            class="text text--secondary"
            :href="comment.album.url + '#comment'"
            style="font-size: 14px"
          >
            {{ $t('serie.read_more') }}
          </a>
        </div>
      </div>
      <!-- Placement of additional controls. Optional -->
      <div class="article-footer">
        <h3 class="text text--right">
          <span
            v-if="comment.count != 0"
            :id="'count-like-' + comment.id"
            :class="comment.liked ? 'button_like_on' : 'button_like_off'"
          >
            ({{ comment.count }})
          </span>
          <span
            :class="comment.liked ? 'button_like_on' : 'button_like_off'"
            @click="likeComment()"
          >
            {{ $t('newsfeed.ilike') }}
            <img :src="require('~/assets/images/like.svg')" />
          </span>
        </h3>
      </div>
    </article>
    <!-- /.review -->
  </div>
  <!-- /.grid-3 -->
  <!-- /.block-content -->
</template>

<script>
import StarRank from '~/components/ui/StarRank'

export default {
  name: 'Comment',
  components: { StarRank },
  props: {
    comment: {
      type: Object,
      required: true
    }
  },

  computed: {
    albumCoverUrl() {
      return `${this.$config.izneoUrl}/${this.$i18n.locale}/images/album/${this.comment.album.ean}-w300.jpg?v=${this.comment.album.version}`
    },
    commentSerieVolume() {
      return `${this.$t('serie.volume', 1).charAt(0)} ${
        this.comment.album.volume
      } ${this.comment.album.serie_name}`
    },
    commentSerieChapter() {
      return `${this.$t('serie.chapter', 1).charAt(0)} ${
        this.comment.album.chapter
      } ${this.comment.album.serie_name}`
    }
  },
  methods: {
    truncateText(value) {
      let text = value
      if (text.length > 290) {
        text = text.slice(0, 290)
        text =
          text.substr(0, Math.min(text.length, text.lastIndexOf(' '))) + '...'
      }

      return '‘‘' + text + '‘‘'
    },
    likeComment: function () {
      const elt = this
      if (this.comment.liked) {
        this.fetch
          .GET(
            '/' +
              this.$i18n.locale +
              '/api/unlike/' +
              elt.comment.type +
              '/' +
              elt.comment.id
          )
          .then((data) => {
            elt.comment.count = data['count']
            elt.comment.liked = false
            elt.$forceUpdate
          })
      } else {
        this.fetch
          .GET(
            '/' +
              this.$i18n.locale +
              '/api/like/' +
              elt.comment.type +
              '/' +
              elt.comment.id
          )
          .then((data) => {
            elt.comment.count = data['count']
            elt.comment.liked = true
            elt.$forceUpdate
          })
      }
    }
  }
}
</script>

<style scoped lang="scss">
.comment_article_container {
  padding-left: 20px;
  padding-bottom: 30px;
  width: calc(100% - 170px);
  float: left;
}

.comment_grid_item {
  background: #ededed;
  margin-bottom: 20px;
  width: 100%;
  padding: 15px;
}

.comment_article {
  height: 100%;
  position: relative;
}

.comment_article_header {
  width: 140px;
  float: left;
  margin-right: 20px;
  margin-bottom: 20px;
  overflow: hidden;
}

.product-thumb {
  position: relative;
}

.product_rating {
  font-size: 13px;
}

.article-footer {
  position: absolute;
  bottom: 0px;
  right: 0px;
}

.button_like_off {
  cursor: pointer;
  color: #686868;
  img {
    height: 20px;
    margin-right: 20px;
  }
}

.button_like_on {
  cursor: pointer;
  color: #ff641e;
  img {
    height: 20px;
    margin-right: 20px;
  }
}

@media (min-width: 1024px) {
  .comment_grid_item {
    width: calc(50% - 15px);
  }

  .comment_article_header {
    padding-bottom: 0;
  }
}
@media (max-width: 768px) {
  .comment_article_header,
  .comment_article_container,
  .product-cover-img {
    width: 100%;
  }

  .product_rating {
    font-size: 25px;
  }
}
@media (min-width: 768px) {
  .comment_grid_item {
    width: calc(50% - 10px);
    padding: 15px;
  }

  .comment_article {
    display: flex;
  }

  .comment_article_header {
    margin: 0;
    max-width: 150px;
    height: auto;
    float: left;
    padding-left: 0px;
    padding-bottom: 15px;
    margin-bottom: -15px;
  }
}
</style>
